


// created : Mahdi Zarkoob
// Kavirelectronic.ir


#include "lpc17xx.h"
#include "rtc.h"
#include "TFTLCD.h"
#include <stdio.h>

extern volatile uint32_t interupt_on;
RTCTime local_time, alarm_time, current_time;


/*********************************************************************************************************
** Function name:       Delay
** Descriptions:        ʱ
** input parameters:    ulTime
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void Delay (uint32_t Time)
{
    uint32_t i;
    
    i = 0;
    while (Time--) {
        for (i = 0; i < 5000; i++);
    }
}

/*****************************************************************************
**   Main Function  main()
******************************************************************************/
int main (void)
{
  char s[4];
	SystemInit();		    		
   //--------------------- LCD setting --------------- 
   tftlcd_init();
   tftlcd_clear(); 
  //---------------- Initialize RTC module --------------- */
  RTCInit();
  //---------------- Set local time ---------------------
  local_time.RTC_Sec = 0;
  local_time.RTC_Min = 10;
  local_time.RTC_Hour = 0;
  local_time.RTC_Mday = 0;
  local_time.RTC_Wday = 0;
  local_time.RTC_Yday = 10;		/* current date 04/12/2012 */
  local_time.RTC_Mon = 6;
  local_time.RTC_Year = 1392;
  RTCSetTime( local_time );		/* Set local time */

  NVIC_EnableIRQ(RTC_IRQn);

  //LPC_RTC->CIIR =  IMMIN ;
  LPC_RTC->CIIR = IMSEC  ;
    
  RTCStart();

  while (1) 
  {					/* Loop forever */
	    current_time = RTCGetTime();
	    if ( interupt_on != 0 )
	    {
	        interupt_on = 0;
	       /* Get current time when alarm is on */
			   tftlcd_clear();
			   tftlcd_Fill(GREEN);
			   tftlcd_gotoxy(1,5);
         tftlcd_puts("Interupt is on",RED,BLUE,1);	
			   Delay(3000);	
	    }

			tftlcd_clear();
			tftlcd_Fill(YELLOW);
			tftlcd_gotoxy(1,5);
      tftlcd_puts("current time is :",RED,BLUE,1);	
			tftlcd_gotoxy(1,7);
			sprintf(s," %i",current_time.RTC_Year);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(6,7);
	    tftlcd_puts(" /",RED,BLUE,1);
			tftlcd_gotoxy(7,7);
			sprintf(s," %i",current_time.RTC_Mon);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(12,7);
	    tftlcd_puts("/",RED,BLUE,1);
			tftlcd_gotoxy(13,7);
			sprintf(s," %i",current_time.RTC_Yday);
			tftlcd_puts(s,BLUE,RED,1);	
			
			tftlcd_gotoxy(1,8);
			sprintf(s," %i",current_time.RTC_Hour);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(4,8);
      tftlcd_puts(":",RED,BLUE,1);
			tftlcd_gotoxy(6,8);
			sprintf(s," %i",current_time.RTC_Min);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(9,8);
			tftlcd_puts(":",RED,BLUE,1);			
			tftlcd_gotoxy(10,8);
			sprintf(s," %i",current_time.RTC_Sec);
			tftlcd_puts(s,BLUE,RED,1);	

	    Delay(3000);
  }

}

/******************************************************************************
**                            End Of File
******************************************************************************/
