

// created : Mahdi Zarkoob
// Kavirelectronic.ir



#include "lpc17xx.h"
#include "rtc.h"
#include "TFTLCD.h"
#include <stdio.h>

extern volatile uint32_t alarm_on;
RTCTime local_time, alarm_time, current_time;

char s[4];
/*********************************************************************************************************
** Function name:       Delay
** Descriptions:        ʱ
** input parameters:    ulTime
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void Delay (uint32_t Time)
{
    uint32_t i;
    
    i = 0;
    while (Time--) {
        for (i = 0; i < 5000; i++);
    }
}
//-----------------------------
void Display_time(void)
{
			current_time = RTCGetTime();
	    tftlcd_clear();
			tftlcd_Fill(YELLOW);
			tftlcd_gotoxy(1,5);
      tftlcd_puts("current time is :",RED,BLUE,1);	
			tftlcd_gotoxy(5,7);
			sprintf(s," %i",current_time.RTC_Year);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(10,7);
	    tftlcd_puts(" /",RED,BLUE,1);
			tftlcd_gotoxy(11,7);
			sprintf(s," %i",current_time.RTC_Mon);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(16,7);
	    tftlcd_puts("/",RED,BLUE,1);
			tftlcd_gotoxy(17,7);
			sprintf(s," %i",current_time.RTC_Yday);
			tftlcd_puts(s,BLUE,RED,1);	
			
			tftlcd_gotoxy(5,8);
			sprintf(s," %i",current_time.RTC_Hour);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(8,8);
      tftlcd_puts(":",RED,BLUE,1);
			tftlcd_gotoxy(10,8);
			sprintf(s," %i",current_time.RTC_Min);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(13,8);
			tftlcd_puts(":",RED,BLUE,1);			
			tftlcd_gotoxy(14,8);
			sprintf(s," %i",current_time.RTC_Sec);
			tftlcd_puts(s,BLUE,RED,1);	
}
void Display_Alarm_time(void)
{
			tftlcd_gotoxy(1,10);
      tftlcd_puts("Alarm time is :",RED,BLUE,1);	
			tftlcd_gotoxy(5,12);
			sprintf(s," %i",alarm_time.RTC_Year);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(10,12);
	    tftlcd_puts(" /",RED,BLUE,1);
			tftlcd_gotoxy(11,12);
			sprintf(s," %i",alarm_time.RTC_Mon);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(16,12);
	    tftlcd_puts("/",RED,BLUE,1);
			tftlcd_gotoxy(17,12);
			sprintf(s," %i",alarm_time.RTC_Yday);
			tftlcd_puts(s,BLUE,RED,1);	
			
			tftlcd_gotoxy(5,13);
			sprintf(s," %i",alarm_time.RTC_Hour);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(8,13);
      tftlcd_puts(":",RED,BLUE,1);
			tftlcd_gotoxy(10,13);
			sprintf(s," %i",alarm_time.RTC_Min);
			tftlcd_puts(s,BLUE,RED,1);	
			tftlcd_gotoxy(13,13);
			tftlcd_puts(":",RED,BLUE,1);			
			tftlcd_gotoxy(14,13);
			sprintf(s," %i",alarm_time.RTC_Sec);
			tftlcd_puts(s,BLUE,RED,1);	
}
//----------------------------
void RTC_IRQHandler(void)
{

	/* This is increment counter interrupt*/
	if ((LPC_RTC->ILR & 0x1) == 1)
	{
		/* Send debug information */
		Display_time();
		Display_Alarm_time();
	  // Clear pending interrupt

	}
	if ((LPC_RTC->ILR & 0x2) == 0x2)
	{
			tftlcd_clear();
			Display_Alarm_time();
		Delay (10000);

	}
			LPC_RTC->ILR |= 0x1;
			LPC_RTC->ILR |= 0x2;
}
/*****************************************************************************
**   Main Function  main()
******************************************************************************/
int main (void)
{
  
	SystemInit();		    		
   //--------------------- LCD setting --------------- 
   tftlcd_init();
   tftlcd_clear(); 
  //---------------- Initialize RTC module --------------- */
  RTCInit();
	//RTCSetAlarmMask(AMRSEC|AMRMIN|AMRHOUR|AMRDOM|AMRDOW|AMRDOY|AMRMON|AMRYEAR);
  //---------------- Set local time ---------------------
  local_time.RTC_Sec = 0;
  local_time.RTC_Min = 10;
  local_time.RTC_Hour = 5;
  local_time.RTC_Mday = 0;
  local_time.RTC_Wday = 0;
  local_time.RTC_Yday = 10;		/* current date 04/12/2012 */
  local_time.RTC_Mon = 6;
  local_time.RTC_Year = 1392;
  RTCSetTime( local_time );		/* Set local time */
  //---------------- set alarm time ---------------------
  alarm_time.RTC_Sec = 10;
  alarm_time.RTC_Min = 10;
  alarm_time.RTC_Hour = 5;
  alarm_time.RTC_Mday = 0;
  alarm_time.RTC_Wday = 0;
  alarm_time.RTC_Yday = 10;		/* alarm date 04/12/2012 */
  alarm_time.RTC_Mon = 6;
  alarm_time.RTC_Year = 1392;
  RTCSetAlarm( alarm_time );		/* set alarm time */

  RTCStart();
 
  LPC_RTC->CIIR = IMSEC ; // enable Sec interupt
//  	LPC_RTC->AMR &= (~AMRSEC & 0xff);
//   LPC_RTC->ILR |= 0x2;
	
  NVIC_EnableIRQ(RTC_IRQn);
	
  while (1) 
  {					/* Loop forever */


  }

}

/******************************************************************************
**                            End Of File
******************************************************************************/
